﻿using System.Collections.Generic;
using System.Windows;
using System.Windows.Data;
using Telerik.Windows.Controls.Data.PropertyGrid;

namespace PropertyGridKeyValue
{ 
    public partial class MainWindow : Window
    {
        public MainWindow()
        {
            InitializeComponent();

            radPropertyGrid.PropertyDefinitions.Clear();
            List<MyKeyValueClass> propertyList = new List<MyKeyValueClass>();
            propertyList.Add(new MyKeyValueClass() { Key = "property1", NestedKeyValuePair = new MyKeyValueClass() { Key = "nestedProperty1", Value = "nestedValue1" } });
            propertyList.Add(new MyKeyValueClass() { Key = "property2", NestedKeyValuePair = new MyKeyValueClass() { Key = "nestedProperty2", Value = "nestedValue2" } });
            propertyList.Add(new MyKeyValueClass() { Key = "property3", NestedKeyValuePair = new MyKeyValueClass() { Key = "nestedProperty3", Value = "nestedValue3" } });


            foreach (MyKeyValueClass mkvc in propertyList)
            {
                var propertyDefinition = new PropertyDefinition()
                {
                    DisplayName = mkvc.Key,
                    Binding = new Binding("NestedKeyValuePair") { Source = mkvc },
                };
                propertyDefinition.NestedProperties.Add(new PropertyDefinition()
                {
                    DisplayName = mkvc.NestedKeyValuePair.Key,
                    Binding = new Binding("Value") { Source = mkvc },
                });
                radPropertyGrid.PropertyDefinitions.Add(propertyDefinition);
            }
            radPropertyGrid.Item = propertyList;
        }
    }

    public class MyKeyValueClass
    {
        public string Key { get; set; }
        public string Value { get; set; }

        public MyKeyValueClass NestedKeyValuePair { get; set; }
    }
}
